=== 3rdparty/OpenAL/CMakeLists.txt ===
# OpenAL
if(USE_SYSTEM_OPENAL)
    if(WIN32)
      find_package(OpenAL CONFIG REQUIRED)
    else()
      find_package(OpenAL REQUIRED)
    endif()
    add_library(3rdparty_openal INTERFACE)
    target_link_libraries(3rdparty_openal INTERFACE OpenAL::OpenAL)
    set_target_properties(OpenAL::OpenAL PROPERTIES IMPORTED_GLOBAL ON)
else()
    option(ALSOFT_UTILS "Build utility programs" OFF)
    option(ALSOFT_EXAMPLES "Build example programs" OFF)
    set(LIBTYPE "STATIC")
    add_subdirectory(openal-soft EXCLUDE_FROM_ALL)
    add_library(3rdparty_openal INTERFACE)
    target_link_libraries(3rdparty_openal INTERFACE OpenAL::OpenAL)
endif()
