=== debian/changelog ===
rpcs3 (0.0.37+git20250928.6fe6c4e+ds-1) unstable; urgency=medium

  * Initial release. (Closes: #1115648)

 -- Ahmad Khalifa <ahmad@khalifa.ws>  Sun, 28 Sep 2025 22:20:24 +0100
