=== debian/control ===
Source: rpcs3
Section: otherosfs
Priority: optional
Maintainer: Ahmad Khalifa <ahmad@khalifa.ws>
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 gamemode-dev,
 glslang-dev,
 glslang-tools,
 libasmjit-dev,
 libasound2-dev,
 libcubeb-dev,
 libcurl4-gnutls-dev,
 libdiscord-rpc-dev,
 libedit-dev,
 libevdev-dev,
 libfaudio-dev,
 libflatbuffers-dev,
 libfusion-dev,
 libglew-dev,
 libhidapi-dev,
 libjack-jackd2-dev,
 libminiupnpc-dev,
 libopenal-dev,
 libopencv-dev,
 libpugixml-dev,
 libpulse-dev,
 librtmidi-dev,
 libsdl2-dev,
 libsdl3-dev,
 libsndio-dev,
 libsoundtouch-dev,
 libstb-dev,
 libudev-dev,
 libusb-1.0-0-dev,
 libvulkan-dev,
 libvulkan-memory-allocator-dev,
 libyaml-cpp-dev,
 libzstd-dev,
 llvm-dev,
 ninja-build,
 qt6-base-dev,
 qt6-base-private-dev,
 qt6-multimedia-dev,
 qt6-svg-dev,
 zlib1g-dev,
Standards-Version: 4.7.2
Homepage: https://rpcs3.net/
Vcs-Browser: https://salsa.debian.org/ahmadkhalifa/rpcs3
Vcs-Git: https://salsa.debian.org/ahmadkhalifa/rpcs3.git

Package: rpcs3
Architecture: linux-amd64
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: PlayStation 3 emulator and debugger
 Emulator for the Cell Broadband Engine Architecture used on PS3
 consoles. Capable of booting and playing a decent amount of
 commercial PS3 games.
 .
 Project maintains a compatibility list for games on their Wiki.
