=== debian/watch ===
version=4

opts="mode=git, pretty=0.0.37+git%cd.%h, repacksuffix=+ds, \
    dversionmangle=s/\+ds$//, uversionmangle=s/^v//" \
    https://github.com/RPCS3/rpcs3.git HEAD

# gitmodules does not work with HEAD, switch to MUT
opts="mode=git, pretty=mod-soundtouch-0.0+git%cd.%h, component=mod-soundtouch" \
    https://github.com/RPCS3/soundtouch.git HEAD ignore

opts="mode=git, pretty=mod-glslang-15.3.0+git%cd.%h, component=mod-glslang" \
    https://github.com/KhronosGroup/glslang.git refs/tags/(15.3.0) ignore

opts="mode=git, pretty=mod-wolfssl-5.8.0+git%cd.%h, component=mod-wolfssl" \
    https://github.com/wolfSSL/wolfssl.git refs/tags/v(5.8.0)-stable ignore uupdate


# refs/tags/v([\d\.]+)
#opts="mode=git, gitmode=full, gitexport=all, pretty=0.0.37+git%cd.%h, \
#    repacksuffix=+ds, dversionmangle=s/\+ds$//, \
#    gitmodules=3rdparty/SoundTouch/soundtouch;3rdparty/glslang" \
#    https://github.com/RPCS3/rpcs3.git HEAD


#opts="mode=git, pretty=describe, component=soundtouch" \
#    https://github.com/RPCS3/soundtouch.git HEAD ignore
#pretty=soundtouch.0.4.10+git%cd.%h,
